# -*- coding: utf-8 -*-
"""
Created on Thu Jan 31 11:03:02 2019

@author: Federico Perrone
"""
from Goal import *
from ReadKnowledgeBase import *
from wordNet_goal import *

def main():
    f = ReadKnowledgeBase() 
    
    
    goals = Goal()
    
    
    for goal in goals.goals:# scandisco tutti i goal da trovare
        result, object_head, object_modifier = goals.resolve_goal(goal, f.knowledge_base)#cerco di risolverli
        print("--------------------------------------------------")
        if result is None: # nessun risultato trovato 
            print("non siamo riusciti a trovare nessun risultato riproviamo ad modificare il goal attraverso i synset")
            
            found = False
            #prendo le parole che non sono contenute nell'ontologia
            words = goals.no_goal_property_in_knowledge_base(goal,f.knowledge_base) 
            print(words)
            if words: #se ci sono parole
                #formulo i nuovi goal con il goal non risolto e le parole non trovate nell'ontologia
               new_goals =  new_goal_synonyms_hypernym_hyponyms(goal,words,f.knowledge_base)
               for go in new_goals:#per ogni nuovo goal
                   print (go)
                   print("-------------------------")
                   result, object_head, object_modifier = goals.resolve_goal(go, f.knowledge_base)
                   if result is not None and object_head is None and object_modifier is None:
                       #abbiamo trovato il nuovo goal in un oggetto dell'ontologia
                       print("abbiamo trovato le proprietà del goal " + str(go) + " nell'oggetto " + str(result))
                       found = True
                       break
                   elif result is not None and object_head is not None and object_modifier is not  None:
                       #abbiamo trovato il nuovo goal fundendo due oggetti dell'onotologia
                       print ("le nuove proprietà del goal " + str(go) +" le abbiamo trovate fondendo: " + str(object_head) +" con " + str(object_modifier))
                       print(result)
                       found = True
                       break
               if found == False: #non abbiamo trovato nessun risultato per questo goal
                    print("non siamo riusciti a trovare il goal! Abbiamo provato anche con gli sinomini, iperonimi e iponimi")
            else:   
                print("non siamo riusciti a trovare il goal!")
        #abbiamo trovato dei risultati
        elif object_head is None and object_modifier is None:
            print ("le proprietà del goal erano contenuti nell'oggetto: " + str(result))
        else:
            print ("le proprietà del goal le abbiamo trovate fondendo: " + str(object_head) +" con " + str(object_modifier))
            print(result)
        print("--------------------------------------------------")

main()
